; tW[SC2004(20*4s)\Tv Version 1.00
;
; File:        lcd4a.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/09 21:00
;
; 20ӕ*4stɂΉ(ds̔zuSC1602ƈقȂ̂Œ)
; LCD_LOCATE}NƃTu[`lcd_ddramɂCӂ̈ʒuɕ\\
;
; t\
;       01234567890123456789
;       SC2004 LCD          
;       20Ӽ*4ޮ         
;       Test
;            
;       PIC18F14K50
;        ROM 16K
;         RAM 768
;          Hello

        #INCLUDE <p18f14k50.inc>
        #INCLUDE "lcd2.inc"

        ; U(12MHz) NbN PLLL(*4)
        ; EHb`hbO^C} dvO݃[h
        CONFIG FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF

           UDATA   ; ϐ̒` oN0
Tcount1     RES 1      ; wait
Tcount2     RES 1      ; wait
Tcount3     RES 1      ; wait
LCD_WRITE   RES 1      ; writef[^w
LCD_TEMP    RES 1
Temp1       RES 1      ; Tu[`p̕ϐ
ARG1        RES 1      ; Tu[`
BYTE2HEX_TEMP RES 1

ARGL        RES 1
ARGH        RES 1

LCD_BUF     RES LCD_CMAX*LCD_RMAX     ; tpobt@

        GLOBAL  LCD_WRITE,LCD_TEMP,ARG1,ARGL,ARGH
        GLOBAL  Temp1,BYTE2HEX_TEMP
        GLOBAL  Tcount1,Tcount2,Tcount3

; vÕAhXadsTBLPTRWX^ɐݒ
LDTBLPTR MACRO   ads
        movlw   UPPER ads
        movwf   TBLPTRU
        movlw   HIGH ads
        movwf   TBLPTRH
        movlw   LOW ads
        movwf   TBLPTRL
        ENDM

        CODE
        ORG 0
        goto   start    ;   Zbg

start
        clrf    ANSEL   ; RC3-RC0,RA4fW^̓obt@ɐݒ
        clrf    ANSELH  ; RB5-RB4,RC7-RC6fW^̓obt@ɐݒ
        clrf    SLRCON  ; PORTA,PORTB,PORTCX[[gWɐݒ
        clrf    TRISA   ; PORTASo͂ɐݒ
        movlw   0f0h
        movwf   TRISB   ; RB7-RB4͂ɐݒ
        clrf    TRISC   ; PORTCSo͂ɐݒ肷
        clrf    PORTC   ; PORTCS0ɂB

        rcall   lcd_init    ;   t

        LDTBLPTR lcd_init_str
        lfsr    FSR0,LCD_BUF
        movlw   LCD_CMAX*LCD_RMAX
        call    prog2mem
        lfsr    FSR1,LCD_BUF
        call    lcd_disp

        movlw   d'200'      ; 10ms*200=2s
wait_loop
        call    wait10
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     wait_loop

        clrf    WREG
        call    lcd_ddram

        LDTBLPTR row1_str
        lfsr    FSR0,LCD_BUF
        movlw   d'11'
        call    prog2mem
        movlw   d'11'

        lfsr    FSR1,LCD_BUF
        call    lcd_puts

        LCD_LOCATE  1,1
        call    lcd_ddram
        LDTBLPTR    row2_str
        lfsr    FSR0,LCD_BUF
        movlw   7
        call    prog2mem
        movlw   7
        lfsr    FSR1,LCD_BUF
        call    lcd_puts

        LCD_LOCATE_XY  2,2
        call    lcd_ddramxy
        LDTBLPTR    row3_str
        lfsr    FSR0,LCD_BUF
        movlw   7
        call    prog2mem
        movlw   7
        lfsr    FSR1,LCD_BUF
        call    lcd_puts

        LCD_LOCATE  3,3
        call    lcd_ddram

        LDTBLPTR    row4_str
        lfsr    FSR0,LCD_BUF
        movlw   5
        call    prog2mem
        movlw   5
        lfsr    FSR1,LCD_BUF
        call    lcd_puts

        bra     $

lcd_init_str    ;0123456789abcdef0123
        DB      "01234567890123456789"
        DB      "SC2004 LCD          "
        DB      "20Ӽ*4ޮ         "
        DB      "Test                "

row1_str
        DB      "PIC18F14K50"
row2_str
        DB      "ROM 16K"
row3_str
        DB      "RAM 768"
row4_str
        DB      "Hello"

prog2mem    ; vOf[^[փRs[ TABLAT->FSR0
        movwf   Temp1
prog2mem_loop
        tblrd   *+          ;   vOTBLPTRǂݏoTBLPTR+1
        movf    TABLAT,W
        movwf   POSTINC0    ;   ԐڃAhbVO@AhX̓ANZX+1
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     prog2mem_loop
        return

        END



