; LCDW[(SC1602/SC2004) 4bit[hCu[  Version 1.20
; File:        lcd2.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/09 21:00

        #INCLUDE <p18f14k50.inc>

        EXTERN  LCD_WRITE,LCD_TEMP,Temp1,ARGL,ARGH
        EXTERN  ARG1
        EXTERN  Tcount1,Tcount2,Tcount3
        GLOBAL  wait50,wait10
        GLOBAL  lcd_init,lcd_disp,lcd_puts
        GLOBAL  lcd_ddramxy,lcd_ddram

        #DEFINE LCD2_ASM

        #INCLUDE "LCD2.INC"

;   ڑ@
;   PIC18F14K50  SC1602/SC2004
;       RC7 ----> DB7
;       RC6 ----> DB6
;       RC5 ----> DB5
;       RC4 ----> DB4
;       RC3 ----> E
;       RC2 ----> RS
;       GND       R/W


LCD_E    EQU     3  ;   EM̃rbgʒu
LCD_RS   EQU     2  ;   RSM̃rbgʒu
LCD_E_MASK  EQU  b'00001000'
LCD_RS_MASK EQU  b'00000100'
LCD_ADS  EQU     PORTC  ;   f[^[4bitEEERSM̃|[g

        CODE

;  \pAhXݒ (x)ƍs(y)Ŏw

lcd_ddramxy ;   \pʒu   rbgtH[}bg yyx xxxx
        movwf   Temp1
        bcf     LCD_ADS,LCD_RS
        clrf    LCD_WRITE
        btfsc   Temp1,6
        bra     lcd_ddramxy_y2l ;   y2ȏ̎ 2,3
        bra     lcd_ddramwy_y1l ;   ybit5쐬
lcd_ddramxy_y2l
        bsf     LCD_WRITE,4
        bsf     LCD_WRITE,2
lcd_ddramwy_y1l
        btfsc   Temp1,5
        bsf     LCD_WRITE,6     ;   y=1,3̂Ƃbit61ɂ
        bsf     LCD_WRITE,7
        movf    Temp1,W
        andlw   b'00011111'
        addwf   LCD_WRITE,F
        rcall   lcd_out8
        movlw   d'1'
        rcall   wait50
        return


lcd_ddram   ; \pAhXݒ
        movwf   LCD_WRITE
        bsf     LCD_WRITE,7
        bcf     LCD_ADS,LCD_RS
        call    lcd_out8
        movlw   d'1'           ;   50s̑ҋ@
        call    wait50
        return

lcd_init    ; t
        movlw   d'200'          ;   50s*200=10ms̑ҋ@
        call    wait50
        movlw   d'100'          ;   50s*100=5ms̑ҋ@
        call    wait50

        bcf     LCD_ADS,LCD_RS  ;   RS 0o
        movlw   b'00110000'
        movwf   LCD_WRITE
        call    lcd_out4
        movlw   d'100'           ;   50s*100=5ms̑ҋ@
        call    wait50

        movlw   b'00110000'
        movwf   LCD_WRITE
        call    lcd_out4
        movlw   d'80'           ;   50s*80=4ms̑ҋ@
        call    wait50

        movlw   b'00110000'
        movwf   LCD_WRITE
        call    lcd_out4
        movlw   d'80'           ;   50s*80=4ms̑ҋ@
        call    wait50

        movlw   b'00100000'
        movwf   LCD_WRITE
        call    lcd_out4
        movlw   d'80'           ;   50s*80=4ms̑ҋ@
        call    wait50

        movlw   b'00101000'
        movwf   LCD_WRITE
        call    lcd_out8
        movlw   d'80'           ;   50s*80=4ms̑ҋ@
        call    wait50

        movlw   b'00001110'     ;   \on
        movwf   LCD_WRITE
        call    lcd_out8
        movlw   d'4'           ;   50s*4=0.2ms̑ҋ@
        call    wait50

        movlw   b'00000110'     ;   Gg[[h
        movwf   LCD_WRITE
        call    lcd_out8
        movlw   d'4'           ;   50s*4=0.2ms̑ҋ@
        call    wait50

        movlw   b'00000001'     ;   \NA
        movwf   LCD_WRITE
        call    lcd_out8
        movlw   d'40'           ;   50s*40=2ms̑ҋ@
        call    wait50
        return

lcd_disp ; t\p̃obt@(tŕ\\ȕKv)̕tɕ\

        movlw   LCD_RMAX
        movwf   ARGH        ;   sJEg
        clrf    ARGL        ;   tsAhX
        movf    ARGL,W

lcd_disp_row_loop
        rcall   lcd_ddramxy ;   LCD\sݒ

        bsf     LCD_ADS,LCD_RS  ;   RS 1o
        movlw   LCD_CMAX
        movwf   ARG1       ;   JEg

lcd_disp_cram_loop
        movf    POSTINC1,W
        movwf   LCD_WRITE
        call    lcd_out8

        movlw   d'1'           ;   50s̑ҋ@
        call    wait50

        decfsz  ARG1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     lcd_disp_cram_loop

        movlw   d'32'
        addwf   ARGL,f
        movf    ARGL,W
        decfsz  ARGH       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     lcd_disp_row_loop
        return

lcd_out4          ; LCD_WRITE4bitLCD֑M
                  ; RS͂炩߃ZbgĂKv 4bit͖B
        movf    LCD_ADS,W
        andlw   0fh    ;   4bit0ɂ
        movwf   LCD_TEMP
        movf    LCD_WRITE,W
        andlw   0f0h    ; 4bit0ɂ
        iorwf   LCD_TEMP,w
        movwf   LCD_ADS
        bsf     LCD_ADS,LCD_E   ;   EZbgb
        nop
        nop
        nop
        bcf     LCD_ADS,LCD_E   ;   ENA

        return

lcd_puts ; t\ FSR1:AhX WREG:
        movwf   Temp1
lcd_puts_1row_loop
        bsf     LCD_ADS,LCD_RS  ;   RS 1o
        movf    POSTINC1,W
        movwf   LCD_WRITE
        call    lcd_out8
        movlw   d'1'           ;   50s̑ҋ@
        call    wait50

        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     lcd_puts_1row_loop

        return

lcd_out8           ;   8bitʂƉʂɕLCD֑M
                   ;   RS͂炩߃ZbgĂKv
        call    lcd_out4
        swapf   LCD_WRITE   ;   4bitƉ4bitւ
        call    lcd_out4
        return

wait50                 ; 50s*[LOWX^ҋ@
    	movwf   Tcount2
dloop21
        movlw   d'199' 
        movwf   Tcount3
        nop
dloop31
    	decfsz  Tcount3
    	goto    dloop31
    	decfsz  Tcount2
    	goto    dloop21
        return

wait10                  ; 10msҋ@
    	movlw d'200'
    	movwf Tcount2
dloop22
        movlw d'199'
        movwf Tcount3
        nop
dloop32
    	decfsz Tcount3
    	goto dloop32
    	decfsz Tcount2
    	goto dloop22
        return

        END



